## libtemplates-parser 23.0.0

=== Makefile ===
############################################################################
#                              Ada Web Server                              #
#                                                                          #
#                     Copyright (C) 2003-2020, AdaCore                     #
#                                                                          #
#  This is free software;  you can redistribute it  and/or modify it       #
#  under terms of the  GNU General Public License as published  by the     #
#  Free Software  Foundation;  either version 3,  or (at your option) any  #
#  later version.  This software is distributed in the hope  that it will  #
#  be useful, but WITHOUT ANY WARRANTY;  without even the implied warranty #
#  of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU     #
#  General Public License for  more details.                               #
#                                                                          #
#  You should have  received  a copy of the GNU General  Public  License   #
#  distributed  with  this  software;   see  file COPYING3.  If not, go    #
#  to http://www.gnu.org/licenses for a complete copy of the license.      #
############################################################################

.SILENT:

VERSION	= 22.0

DEBUG        = false
TP_TASKING   = Standard_Tasking
PROCESSORS   = 0
HOST         := $(shell gcc -dumpmachine)
TARGET       := $(shell gcc -dumpmachine)
prefix       := $(dir $(shell which gnatls))..
DEFAULT_LIBRARY_TYPE	= static

GNAT         := gnat

ENABLE_STATIC = true
ENABLE_SHARED := $(shell $(GNAT) make -c -q -p -XTARGET=$(TARGET) \
			-Pconfig/setup/test_shared 2>/dev/null && echo "true")

ifeq ($(shell gnat ls -Pxmlada_dom 2>&1 | grep 'project file .* not found'),)
  TP_XMLADA := Installed
else
  TP_XMLADA := Disabled
endif

-include makefile.setup

ifeq ($(HOST), $(TARGET))
GPROPTS		=
TPREFIX=$(DESTDIR)$(prefix)
else
GPROPTS		= --target=$(TARGET)
TPREFIX=$(DESTDIR)$(prefix)/$(TARGET)
endif

MODE		= $(if $(filter-out true,$(DEBUG)),release,debug)
SDIR		= $(TARGET)/$(MODE)

GPRBUILD	= gprbuild
GPRINSTALL	= gprinstall
GPRCLEAN	= gprclean

#  Compute the default library kind, and possibly the other that are to
#  be built.

ifeq ($(DEFAULT_LIBRARY_TYPE),shared)
  ifneq ($(ENABLE_SHARED),true)
    $(error shared not enabled, cannot be the default)
  endif
endif

ifeq ($(DEFAULT_LIBRARY_TYPE),static)
  ifneq ($(ENABLE_STATIC),true)
    $(error static not enabled, cannot be the default)
  endif
endif

ifeq ($(ENABLE_STATIC), true)
   STATIC_LIBRARY=static
endif

ifeq ($(ENABLE_SHARED), true)
   LIBRARY_TYPES=$(STATIC_LIBRARY) relocatable static-pic
endif

ifeq ($(DEBUG), true)
  PRJ_BUILD := Debug
else
  PRJ_BUILD := Release
endif

ALL_OPTIONS := \
 DEBUG \
 DEFAULT_LIBRARY_TYPE \
 ENABLE_SHARED \
 ENABLE_STATIC \
 GNAT \
 GPRBUILD \
 GPRCLEAN \
 PRJ_BUILD \
 PROCESSORS \
 SDIR \
 TARGET \
 TP_XMLADA \
 VERSION \
 prefix

override GPROPTS += $(foreach v, \
 PRJ_BUILD TP_XMLADA PROCESSORS TARGET VERSION \
 ,"-X$(v)=$($(v))")

GPR_DEFAULT = -XLIBRARY_TYPE=$(DEFAULT_LIBRARY_TYPE) \
		-XXMLADA_BUILD=$(DEFAULT_LIBRARY_TYPE)

#########
# build #
#########

build: $(LIBRARY_TYPES:%=build-%) build-tools

build-%: tp_xmlada.gpr makefile.setup
	$(GPRBUILD) -p $(GPROPTS) -XLIBRARY_TYPE=$* -XXMLADA_BUILD=$* \
		--subdirs=$(SDIR)/$* -Ptemplates_parser

build-tools: build-$(DEFAULT_LIBRARY_TYPE)
	$(GPRBUILD) -p $(GPROPTS) $(GPR_DEFAULT) \
		--subdirs=$(SDIR)/$(DEFAULT_LIBRARY_TYPE) -Ptools/tools

run_regtests test: build makefile.setup
	$(MAKE) -C regtests test

DOC_FORMATS := html latexpdf
build-doc: tp_xmlada.gpr makefile.setup
	$(MAKE) -C docs $(DOC_FORMATS)
	echo Templates_Parser Documentation built with success.

#########
# setup #
#########

tp_xmlada.gpr:
ifeq ($(TP_XMLADA), Installed)
	cp config/tp_xmlada_installed.gpr tp_xmlada.gpr
else
	cp config/tp_xmlada_dummy.gpr tp_xmlada.gpr
endif

force:

makefile.setup: setup

setup: tp_xmlada.gpr force
	printf " $(foreach v,$(ALL_OPTIONS),$(v) = $($(v))\n)" > makefile.setup

###########
# install #
###########

uninstall:
ifneq (,$(wildcard $(TPREFIX)/share/gpr/manifests/templates_parser))
	-$(GPRINSTALL) $(GPROPTS) -f --uninstall \
		--prefix=$(TPREFIX) templates_parser
endif

GPRINST_OPTS=-p -f --prefix=$(TPREFIX) \
	--build-var=LIBRARY_TYPE --build-var=TEMPLATES_PARSER_BUILD

install: uninstall $(LIBRARY_TYPES:%=install-%)
	$(GPRINSTALL) $(GPROPTS) $(GPR_DEFAULT) $(GPRINST_OPTS) \
		--mode=usage --subdirs=$(SDIR)/$(DEFAULT_LIBRARY_TYPE) \
		--install-name=templates_parser -Ptools/tools

install-%:
	$(GPRINSTALL) $(GPROPTS) -XLIBRARY_TYPE=$* -XXMLADA_BUILD=$*\
		$(GPRINST_OPTS) --subdirs=$(SDIR)/$* --build-name=$* -Ptemplates_parser

#########
# clean #
#########

clean: $(LIBRARY_TYPES:%=clean-%)
	-$(GPRCLEAN) $(GPR_DEFAULT) $(GPROPTS) -Ptools/tools
	$(MAKE) -C docs clean
	$(MAKE) -C regtests clean
	rm -f auto.cgpr config/setup/auto.cgpr
	rm -fr .build makefile.setup
	rm -f config/setup/foo.ali config/setup/foo.o tp_xmlada.gpr
	rm -f config/setup/foo.ads.std*

clean-%:
	-$(GPRCLEAN) -XLIBRARY_TYPE=$* -XXMLADA_BUILD=$* $(GPROPTS) \
		-Ptemplates_parser

=== regtests/Makefile ===
############################################################################
#                              Ada Web Server                              #
#                                                                          #
#                     Copyright (C) 2003-2017, AdaCore                     #
#                                                                          #
#  This is free software;  you can redistribute it  and/or modify it       #
#  under terms of the  GNU General Public License as published  by the     #
#  Free Software  Foundation;  either version 3,  or (at your option) any  #
#  later version.  This software is distributed in the hope  that it will  #
#  be useful, but WITHOUT ANY WARRANTY;  without even the implied warranty #
#  of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU     #
#  General Public License for  more details.                               #
#                                                                          #
#  You should have  received  a copy of the GNU General  Public  License   #
#  distributed  with  this  software;   see  file COPYING3.  If not, go    #
#  to http://www.gnu.org/licenses for a complete copy of the license.      #
############################################################################

.SILENT:

-include ../makefile.setup

build:
	$(GPRBUILD) -q -p -XLIBRARY_TYPE=$(DEFAULT_LIBRARY_TYPE) \
		$(foreach v,PRJ_BUILD TARGET VERSION,"-X$(v)=$($(v))") \
		--subdirs=$(SDIR)/$(DEFAULT_LIBRARY_TYPE) -Pregtests

test:  build
	ADA_PROJECT_PATH="$(abspath $(CURDIR)/..)" \
	PATH=.:${PATH} \
	$(foreach v,PRJ_BUILD TARGET TP_XMLADA,$(v)="$($(v))") \
	./testsuite.py --jobs=4

clean:
	-$(GPRCLEAN) -XLIBRARY_TYPE=$(DEFAULT_LIBRARY_TYPE) \
		$(foreach v,PRJ_BUILD TARGET VERSION,"-X$(v)=$($(v))") \
		--subdirs=$(SDIR)/$(DEFAULT_LIBRARY_TYPE) -Pregtests
	rm -fr out
	rm -f *.pyc

=== debian/changelog ===
libtemplates-parser (23.0.0-5) experimental; urgency=medium

  * Rebuild with a version of libxmlada changing its shared object version.
  * Increase the shared object version for the same reason (gnat-13).

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 28 Oct 2023 22:45:15 +0000

libtemplates-parser (23.0.0-4) experimental; urgency=medium

  * Build in experimental with dh-ada-library >= 9 and gnat >= 13.
  * Rename -dev package, now unversioned. Provide a name containing a hash.
  * Build-Depend: gnat instead of gnat-13. Break/Replace previous -devs.
  * Move the dh-sequence-ada-library virtual package alongside the
    concrete package carrying its version restriction.
  * Make the unversioned -dev package explicit in debhelper configuration.

 -- Nicolas Boulenguez <nicolas@debian.org>  Wed, 25 Oct 2023 16:16:45 +0000

libtemplates-parser (23.0.0-3) unstable; urgency=medium

  * Break/Replace libtemplates-parser*-dev since oldstable.
    Closes: #1034985.

 -- Nicolas Boulenguez <nicolas@debian.org>  Wed, 10 May 2023 22:52:11 +0200

libtemplates-parser (23.0.0-2) unstable; urgency=medium

  * Reupload to unstable for the gnat-12 transition.
  * Standards-Version: 4.6.2 (no changes).

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 27 Dec 2022 01:16:17 +0100

libtemplates-parser (23.0.0-1) experimental; urgency=medium

  * Build with unicode 15. No -dev renamings in experimental.
  * New upstream version (unchanged from the preview).

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 26 Nov 2022 11:57:28 +0000

libtemplates-parser (23~20220629-1) experimental; urgency=medium

  * Build new snapshot with gcc-12 for experimental.
    Rename -dev package (ALI version), but not lib package (SO version).
    Drop applied xmlada-split.diff
  * Update to dh-ada-library 8.1.
    The Makefile snippet is also needed by -indep builds.
    Drop patches related with build directory structure or soname convention.
  * Remove artifacts from project. PDF docs are not built during -arch
    builds and must be installed manually.
  * Standards-Version 4.6.1
  * Update copyright years
  * Clean a forgotten GNAT temporary file
  * Avoid parallelism in both make and gprbuild
  * Force TP_XMLADA, incorrectly detected with gcc-12
  * Move some cleaning from debian/rules to debian/clean.
  * Prefer execute_before to override/remaining-packages.

 -- Nicolas Boulenguez <nicolas@debian.org>  Mon, 29 Aug 2022 05:27:28 +0000

=== debian/control ===
Source: libtemplates-parser
Section: libdevel
Priority: optional
Maintainer: Ludovic Brenta <lbrenta@debian.org>
Uploaders: Xavier Grave <xavier.grave@csnsm.in2p3.fr>,
 Nicolas Boulenguez <nicolas@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 dh-ada-library (>= 9),
 dh-sequence-ada-library,
 gnat (>= 13.1),
 gprbuild (>= 2017),
# This version cleans auto.cgpr after the build.
# See xsrc/templates_parser-xml.adb.
 libxmlada-dom-dev (>= 23.0.0-6),
 libxmlada-input-dev (>= 23.0.0-6),
 libxmlada-sax-dev (>= 23.0.0-6),
 libxmlada-unicode-dev (>= 23.0.0-6),
Build-Depends-Indep:
 dh-sequence-sphinxdoc,
 latexmk,
 python3-sphinx,
 tex-gyre,
 texinfo,
# Sphinx >= 1.6 uses the latexmk driver.
 texlive-fonts-recommended,
 texlive-latex-extra,
 texlive-latex-recommended,
# sphinx-doc requires iftex.sty:
 texlive-plain-generic,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://github.com/AdaCore/templates-parser
Vcs-Browser: https://salsa.debian.org/debian/libtemplates-parser
Vcs-Git: https://salsa.debian.org/debian/libtemplates-parser.git

Package: libtemplates-parser-dev
Breaks: libtemplates-parser12-dev, libtemplates-parser13-dev, libtemplates-parser14-dev,
 libtemplates-parser15-dev, libtemplates-parser16-dev
Replaces: libtemplates-parser12-dev, libtemplates-parser13-dev, libtemplates-parser14-dev,
 libtemplates-parser15-dev, libtemplates-parser16-dev
Provides: ${ada:Provides}
Architecture: any
Depends: ${ada:Depends}, ${shlibs:Depends}, ${misc:Depends}
# No need to Depend: libxmlada*-dev
# because the generated project does not need to import "xmlada.gpr"
# because XMLada is only used by a body in templates-parser.
Suggests: libtemplates-parser-doc
Description: Ada library to parse files and replace variables
 The main goal is to ease the development of Web servers. In CGI
 (Common Gateway Interface) applications, you have to write  HTML pages in
 the program (in Ada or whatever other language) by using some specific
 libraries or by using only basic output functions.  This is of course not
 mandatory but by lack of a good library every Web development ends up doing
 just that.  Templates Parser takes that burden off of you.
 .
 This package contains the static libraries, documentation, tools and Ada
 specification files.

# On next so change, add a dash between the name and the SO
# version in order to silent a lintian warning.
Package: libtemplates-parser21
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Ada library to parse files and replace variables (runtime)
 The main goal is to ease the development of Web servers. In CGI
 (Common Gateway Interface) applications, you have to write  HTML pages in
 the program (in Ada or whatever other language) by using some specific
 libraries or by using only basic output functions.  This is of course not
 mandatory but by lack of a good library every Web development ends up doing
 just that.  Templates Parser takes that burden off of you.
 .
 This package contains the runtime shared library.

Package: libtemplates-parser-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Built-Using: ${sphinxdoc:Built-Using}
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Suggests: gnat
Description: Ada library to parse files and replace variables (documentation)
 The main goal is to ease the development of Web servers. In CGI
 (Common Gateway Interface) applications, you have to write  HTML pages in
 the program (in Ada or whatever other language) by using some specific
 libraries or by using only basic output functions.  This is of course not
 mandatory but by lack of a good library every Web development ends up doing
 just that.  Templates Parser takes that burden off of you.
 .
 This package contains the documentation for developers using the library.

## libtemplates-parser 24.0.0

=== Makefile ===
--- 
+++ 
@@ -16,7 +16,9 @@
 #  to http://www.gnu.org/licenses for a complete copy of the license.      #
 ############################################################################
 
+ifndef VERBOSE_MAKE
 .SILENT:
+endif
 
 VERSION	= 22.0
 
@@ -84,6 +86,28 @@
   PRJ_BUILD := Debug
 else
   PRJ_BUILD := Release
+endif
+
+ifeq ($(strip $(findstring linux, $(TARGET))),linux)
+   PRJ_TARGET=Linux
+else
+ifeq ($(strip $(findstring mingw32, $(TARGET))),mingw32)
+   PRJ_TARGET=Windows
+else
+ifeq ($(strip $(findstring cygwin, $(TARGET))),cygwin)
+   PRJ_TARGET=Windows
+else
+ifeq ($(strip $(findstring darwin, $(TARGET))),darwin)
+   PRJ_TARGET=macOS
+else
+ifeq ($(strip $(findstring freebsd, $(TARGET))),freebsd)
+   PRJ_TARGET=FreeBSD
+else
+   PRJ_TARGET=UNIX
+endif
+endif
+endif
+endif
 endif
 
 ALL_OPTIONS := \
@@ -95,6 +119,7 @@
  GPRBUILD \
  GPRCLEAN \
  PRJ_BUILD \
+ PRJ_TARGET \
  PROCESSORS \
  SDIR \
  TARGET \
@@ -103,7 +128,7 @@
  prefix
 
 override GPROPTS += $(foreach v, \
- PRJ_BUILD TP_XMLADA PROCESSORS TARGET VERSION \
+ PRJ_BUILD PRJ_TARGET TP_XMLADA PROCESSORS TARGET VERSION \
  ,"-X$(v)=$($(v))")
 
 GPR_DEFAULT = -XLIBRARY_TYPE=$(DEFAULT_LIBRARY_TYPE) \

=== regtests/Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 ############################################################################
 #                              Ada Web Server                              #
 #                                                                          #
-#                     Copyright (C) 2003-2017, AdaCore                     #
+#                     Copyright (C) 2003-2022, AdaCore                     #
 #                                                                          #
 #  This is free software;  you can redistribute it  and/or modify it       #
 #  under terms of the  GNU General Public License as published  by the     #
@@ -16,24 +16,26 @@
 #  to http://www.gnu.org/licenses for a complete copy of the license.      #
 ############################################################################
 
+ifndef VERBOSE_MAKE
 .SILENT:
+endif
 
 -include ../makefile.setup
 
 build:
 	$(GPRBUILD) -q -p -XLIBRARY_TYPE=$(DEFAULT_LIBRARY_TYPE) \
-		$(foreach v,PRJ_BUILD TARGET VERSION,"-X$(v)=$($(v))") \
+		$(foreach v,PRJ_TARGET PRJ_BUILD TARGET VERSION,"-X$(v)=$($(v))") \
 		--subdirs=$(SDIR)/$(DEFAULT_LIBRARY_TYPE) -Pregtests
 
-test:  build
+test: build
 	ADA_PROJECT_PATH="$(abspath $(CURDIR)/..)" \
 	PATH=.:${PATH} \
-	$(foreach v,PRJ_BUILD TARGET TP_XMLADA,$(v)="$($(v))") \
+	$(foreach v,PRJ_TARGET PRJ_BUILD TARGET TP_XMLADA,$(v)="$($(v))") \
 	./testsuite.py --jobs=4
 
 clean:
 	-$(GPRCLEAN) -XLIBRARY_TYPE=$(DEFAULT_LIBRARY_TYPE) \
-		$(foreach v,PRJ_BUILD TARGET VERSION,"-X$(v)=$($(v))") \
+		$(foreach v,PRJ_TARGET PRJ_BUILD TARGET VERSION,"-X$(v)=$($(v))") \
 		--subdirs=$(SDIR)/$(DEFAULT_LIBRARY_TYPE) -Pregtests
 	rm -fr out
 	rm -f *.pyc

=== debian/changelog ===
libtemplates-parser (24.0.0-2build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 02:17:52 +0000

libtemplates-parser (24.0.0-2) unstable; urgency=medium

  * Reupload to unstable for the gnat-13/time_t64 transition.
    Closes: #1061633.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 17 Mar 2024 15:34:24 +0100

libtemplates-parser (24.0.0-1) experimental; urgency=medium

  * New upstream version, requiring the sphinx read-the-docs theme.
  * Build with dh-ada-library 9.1 for gnat versions in ada:Depends.

 -- Nicolas Boulenguez <nicolas@debian.org>  Wed, 20 Dec 2023 00:19:13 +0000

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,13 @@
 Source: libtemplates-parser
 Section: libdevel
 Priority: optional
-Maintainer: Ludovic Brenta <lbrenta@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Ludovic Brenta <lbrenta@debian.org>
 Uploaders: Xavier Grave <xavier.grave@csnsm.in2p3.fr>,
  Nicolas Boulenguez <nicolas@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
- dh-ada-library (>= 9),
+ dh-ada-library (>= 9.1),
  dh-sequence-ada-library,
  gnat (>= 13.1),
  gprbuild (>= 2017),
@@ -20,6 +21,7 @@
  dh-sequence-sphinxdoc,
  latexmk,
  python3-sphinx,
+ python3-sphinx-rtd-theme,
  tex-gyre,
  texinfo,
 # Sphinx >= 1.6 uses the latexmk driver.

## libtemplates-parser 25.0.0

=== Makefile ===
--- 
+++ 
@@ -42,8 +42,6 @@
   TP_XMLADA := Disabled
 endif
 
--include makefile.setup
-
 ifeq ($(HOST), $(TARGET))
 GPROPTS		=
 TPREFIX=$(DESTDIR)$(prefix)
@@ -75,11 +73,11 @@
 endif
 
 ifeq ($(ENABLE_STATIC), true)
-   STATIC_LIBRARY=static
+   LIBRARY_TYPES += static
 endif
 
 ifeq ($(ENABLE_SHARED), true)
-   LIBRARY_TYPES=$(STATIC_LIBRARY) relocatable static-pic
+   LIBRARY_TYPES += relocatable static-pic
 endif
 
 ifeq ($(DEBUG), true)
@@ -109,6 +107,8 @@
 endif
 endif
 endif
+
+-include makefile.setup
 
 ALL_OPTIONS := \
  DEBUG \

=== docs/Makefile ===
############################################################################
#                              Ada Web Server                              #
#                                                                          #
#                     Copyright (C) 2003-2019, AdaCore                     #
#                                                                          #
#  This is free software;  you can redistribute it  and/or modify it       #
#  under terms of the  GNU General Public License as published  by the     #
#  Free Software  Foundation;  either version 3,  or (at your option) any  #
#  later version.  This software is distributed in the hope  that it will  #
#  be useful, but WITHOUT ANY WARRANTY;  without even the implied warranty #
#  of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU     #
#  General Public License for  more details.                               #
#                                                                          #
#  You should have  received  a copy of the GNU General  Public  License   #
#  distributed  with  this  software;   see  file COPYING3.  If not, go    #
#  to http://www.gnu.org/licenses for a complete copy of the license.      #
############################################################################

# Makefile for Sphinx documentation
#

# default value if this Makefile is called directly on not from above
# Makefile.

GPRBUILD  := gprbuild
PRJ_BUILD := Release

-include ../makefile.setup

TMPLDIR  := src
ADBDIR   := src
EXEDIR   := build/bin/$(SDIR)/static
RESDIR   := build/samples
ADBFILES := $(wildcard $(ADBDIR)/*.adb)
EXEFILES := $(patsubst $(ADBDIR)/%.adb,%,$(ADBFILES))
RESFILES := $(foreach e,$(EXEFILES),$(RESDIR)/$(e).adb.res)

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = build

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest gettext

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	rm -fr $(BUILDDIR) __pycache__
	rm -f *.pyc

# All documentations require the generated examples.
html dirhtml singlehtml pickle json htmlhelp qthelp latex latexpdf text man texinfo info: $(RESFILES)

$(RESFILES): $(RESDIR)/%.adb.res: build-sample | $(RESDIR)
	( cd $(TMPLDIR) > /dev/null && ../$(EXEDIR)/$* ) > $@

$(RESDIR):
	mkdir -p $@

.PHONY: build-sample
build-sample:
	$(GPRBUILD) -p -m -Pdocs $(EXEFILES) \
	  --subdirs=$(SDIR)/static \
	  $(foreach v,PRJ_TARGET PRJ_BUILD TARGET VERSION,"-X$(v)=$($(v))")

# Executable and result will be removed with BUILDDIR.

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/Templates_Parser.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/Templates_Parser.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/Templates_Parser"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/Templates_Parser"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf \
		LATEXOPTS="-interaction=nonstopmode"
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

=== debian/changelog ===
libtemplates-parser (25.0.0-2build1) questing; urgency=medium

  * No-change rebuild for gnat ABI, triggered by glibc 2.42.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 21 Sep 2025 07:46:36 +0200

libtemplates-parser (25.0.0-2) unstable; urgency=medium

  * Reupload to unstable for the gnat-14 transition.

 -- Nicolas Boulenguez <nicolas@debian.org>  Mon, 10 Mar 2025 07:32:09 +0000

libtemplates-parser (25.0.0-1) experimental; urgency=medium

  * Build new upstream release with gnat-14 for experimental.
  * Fix a typo breaking sphinx parallel option
  * Install documentation to now unversioned -dev doc directory
  * Improve gbp.conf.
  * Enable salsa continuous integration via debian/salsa-ci.yml.
  * Update copyright years and Standards-Version.

 -- Nicolas Boulenguez <nicolas@debian.org>  Thu, 02 Jan 2025 00:16:39 +0000

=== debian/control ===
--- 
+++ 
@@ -1,22 +1,20 @@
 Source: libtemplates-parser
 Section: libdevel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Ludovic Brenta <lbrenta@debian.org>
+Maintainer: Ludovic Brenta <lbrenta@debian.org>
 Uploaders: Xavier Grave <xavier.grave@csnsm.in2p3.fr>,
  Nicolas Boulenguez <nicolas@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
  dh-ada-library (>= 9.1),
  dh-sequence-ada-library,
- gnat (>= 13.1),
- gprbuild (>= 2017),
-# This version cleans auto.cgpr after the build.
-# See xsrc/templates_parser-xml.adb.
- libxmlada-dom-dev (>= 23.0.0-6),
- libxmlada-input-dev (>= 23.0.0-6),
- libxmlada-sax-dev (>= 23.0.0-6),
- libxmlada-unicode-dev (>= 23.0.0-6),
+ gnat,
+ gnat-14,
+ gprbuild (>= 2025.0.0-2),
+ libxmlada-dom-dev,
+ libxmlada-input-dev,
+ libxmlada-sax-dev,
+ libxmlada-unicode-dev,
 Build-Depends-Indep:
  dh-sequence-sphinxdoc,
  latexmk,
@@ -30,7 +28,7 @@
  texlive-latex-recommended,
 # sphinx-doc requires iftex.sty:
  texlive-plain-generic,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://github.com/AdaCore/templates-parser
 Vcs-Browser: https://salsa.debian.org/debian/libtemplates-parser

=== debian/rules ===
#!/usr/bin/make -f
# Build script for Templates_Parser in Debian.
# Copyright (c) 2003-2008 Ludovic Brenta <lbrenta@debian.org>
# Copyright (c) 2013-2022 Nicolas Boulenguez <nicolas@debian.org>

# This build script is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 3 of the
# License, or (at your option) any later version.

# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.

# On Debian systems, the full text of the GPL is in the file
# /usr/share/common-licenses/GPL-3.

DPKG_EXPORT_BUILDFLAGS := 1
DEB_BUILD_MAINT_OPTIONS := hardening=+all
DEB_LDFLAGS_MAINT_APPEND := \
  -Wl,--no-allow-shlib-undefined \
  -Wl,--no-copy-dt-needed-entries \
  -Wl,--no-undefined
include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/buildopts.mk
include /usr/share/ada/packaging.mk

# Some options are stored into makefile.setup, but some are not.
# All written options are read back, but some are overriden.
# That is why we force all values on each Make.

# Force detection of TP_XMLADA because of a regression in GCC-12.
# gnat ls -Pxmlada_dom.gpr -aP/usr/share/gpr  -> found
# gnat ls -Pxmlada_dom.gpr -> not found
# gnat ls -v -> says that is searches /usr/share/gpr
# No one will ever fix this, GCC is not supporting projects anymore.

MAKE_OPTS := \
  VERBOSE_MAKE=1 \
  VERSION=$(templates_parser_SO_VERSION) \
  DEFAULT_LIBRARY_TYPE=relocatable \
  TP_XMLADA=Installed \
  GPRBUILD='gprbuild $(GPRBUILDFLAGS:-j%=)' \
  LIBRARY_TYPES='static relocatable' \
  $(DEB_BUILD_OPTION_PARALLEL:%=PROCESSORS=%) \
  $(DEB_BUILD_OPTION_PARALLEL:%=SPHINXOPTS=-j%) \
  DOC_FORMATS="html info latexpdf text"

######################################################################
%:
	dh $@

.PHONY: override_dh_auto_build-arch
override_dh_auto_build-arch:
  # Gprbuild deals with parallelism. Make should not interfer.
	$(MAKE) $(MAKE_OPTS)

.PHONY: override_dh_auto_build-indep
override_dh_auto_build-indep:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
  # Parallelism in Make would create a race condition between sphinx
  # processes.  Anyway, sphinx already uses parallelism.
	$(MAKE) build-doc $(MAKE_OPTS)
endif

# Skip tests, they assume that the executables are in the PATH.
.PHONY: override_dh_auto_test

override_dh_auto_install-arch:
	$(MAKE) $(MAKE_OPTS) install LIBRARY_TYPES= \
	  GPRINST_OPTS='$(standard_GPRINSTALLFLAGS)'
	$(MAKE) $(MAKE_OPTS) install-relocatable \
	  GPRINST_OPTS='$(call shared_GPRINSTALLFLAGS,templates_parser)'
	$(MAKE) $(MAKE_OPTS) install-static \
	  GPRINST_OPTS='$(static_GPRINSTALLFLAGS)'

override_dh_auto_install-indep:

.PHONY: override_dh_auto_clean
override_dh_auto_clean:
	$(MAKE) clean $(MAKE_OPTS)

=== debian/tests/control ===
Tests: link-with-shared
Depends: @, gprbuild

Tests: templatespp

=== debian/watch ===
version=4

https://github.com/AdaCore/templates-parser/tags \
(?:.*?/)?v?(\d[\d.]*)\.tar\.gz
